cryo_agent/publisher/routes/logs.py
from flask import Blueprint, flash, redirect, render_template, request, url_for
from sqlalchemy.orm import Session

from cryo_agent.logic.logs import (
    get_logbook_entries,
    get_logbook_entry,
    modify_logbook_entry,
    write_new_logbook_entry,
)
from cryo_agent.publisher.db import get_engine

bp = Blueprint("logs", __name__, url_prefix="/logs")


@bp.route("/overview/", methods=["GET"])
def overview():
    with Session(get_engine()) as session:
        return render_template(
            "logbook/logs_overview.html",
            entries=get_logbook_entries(session),
        )


@bp.route("/add/", methods=["GET", "POST"])
def add():
    if request.method == "POST":
        with Session(get_engine()) as session:
            username = request.form["fusername"]
            action = request.form["faction"]
            description = request.form["fdescription"]

            # Flash messages that entries are required
            if not username:
                flash("Username is required")
            if not action:
                flash("Action is required")
            if not description:
                flash("Description is required")

            # If all are present, add entry
            if all([username, action, description]):
                write_new_logbook_entry(session, username, action, description)
                return redirect(url_for("logs.overview"))

    # By default, render add page
    return render_template("logbook/logs_add.html")


@bp.route("/details/<int:entry_id>", methods=["GET", "POST"])
def details(entry_id):
    with Session(get_engine()) as session:
        if request.method == "POST":
            username = request.form["fusername"]
            action = request.form["faction"]
            description = request.form["fdescription"]

            # Flash messages that entries are required
            if not username:
                flash("Username is required")
            if not action:
                flash("Action is required")
            if not description:
                flash("Description is required")

            # If all are present, add entry
            if all([username, action, description]):
                modify_logbook_entry(session, entry_id, username, action, description)
                return redirect(url_for("logs.overview"))

        return render_template(
            "logbook/logs_details.html",
            entry=get_logbook_entry(session, entry_id),
        )

cryo_agent/publisher/templates/logbook/logs_add.html
{% extends "base.html" %}

{% set active_page = "logs" %}

{% block content %}
    {% for message in get_flashed_messages() %}
        <div class="alert">{{ message }}</div>
    {% endfor %}

    <div>
        <h1>Add logbook entry</h1>
    </div>

    <div class="logs-add-form">
        <form method="post">
            <label for="fusername">Username:</label> <br>
            <input type="text" , id="fusername" , name="fusername"><br>
            <label for="faction">Action:</label><br>
            <input type="text" , id="faction" , name="faction"><br>
            <label for="fdescription">Description:</label><br>
            <textarea id="fdescription" , name="fdescription"></textarea><br>
            <button class="button-3" type="submit">Submit Log entry</button>
        </form>
    </div>

{% endblock %}

cryo_agent/publisher/templates/logbook/logs_details.html
{% extends "base.html" %}

{% set active_page = "logs" %}

{% block content %}
    {% for message in get_flashed_messages() %}
        <div class="alert">{{ message }}</div>
    {% endfor %}

    <div>
        <h1>Logbook entry detailed overview</h1>
    </div>

    <div class="logs-detail">
        <form method="post">
            <label for="ftimestamp">Timestamp:</label> <br>
            <input readonly type="text" , id="ftimestamp" , name="ftimestamp" , value="{{entry.timestamp}}"><br>
            <label for="fusername">Username:</label> <br>
            <input type="text" , id="fusername" , name="fusername" , value="{{entry.username}}"><br>
            <label for="faction">Action:</label><br>
            <input type="text" , id="faction" , name="faction" , value="{{entry.action}}"><br>
            <label for="fdescription">Description:</label><br>
            <textarea id="fdescription" , name="fdescription">{{entry.description}}</textarea><br>
            <button class="button-3" type="submit">Save log entry</button>
        </form>
    </div>

{% endblock %}

cryo_agent/publisher/templates/logbook/logs_overview.html
{% extends "base.html" %}

{% set active_page = "logs" %}

{% block content %}
    <div>
        <h1>Logbook Overview</h1>
    </div>

    <div class="logs-overview">

        <h2>Select Number Of Rows</h2>
        <div class="form-group">
        <!--		Show Numbers Of Rows 		-->
            <select class="form-control" name="state" id="maxRows">
                <option value="5000">Show ALL Rows</option>
                <option value="5">5</option>
                <option value="10">10</option>
                <option value="15">15</option>
                <option value="20">20</option>
                <option value="50">50</option>
                <option value="70">70</option>
                <option value="100">100</option>
            </select>

        </div>
        <table class="table table-striped table-class" , id="logbook-table">
            <thead>
                <tr>
                    <th>No</th>
                    <th>Entry Date</th>
                    <th>User</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>
                {% for entry in entries %}
                    <tr data-url="{{url_for('logs.details', entry_id=entry.id)}}">
                        <td>{{entry.id}}</td>
                        <td>{{entry.timestamp.strftime('%d-%m-%Y %H:%M:%S')}}</td>
                        <td>{{entry.username}}</td>
                        <td>{{entry.action}}</td>
                    </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>

    <div class='pagination-container'>
        <nav>
            <ul class="pagination">

                <li data-page="prev">
                    <span>
                        < </span>
                </li>
            <!--	Here the JS Function Will Add the Rows -->
                <li data-page="next" id="next">
                    <span>></span>
                </li>
            </ul>
        </nav>
    </div>

    <div class="logs-new-button">
        <button class="button-3">
            <a href="{{ url_for('logs.add') }}">
                Add new log
            </a>
        </button>
    </div>

    <script>
    // Setup pagination
        getPagination('#logbook-table');

    // Setup click handler for tbody rows
        $(function () {
            $('#logbook-table tbody tr').click(function () {
                window.location.href = $(this).data('url');
            });
        })
    </script>
{% endblock %}